"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setCookie = setCookie;

var _cookie = require("cookie");

function setCookie(res, cookie) {
  var _res$getHeader;

  const {
    name,
    value,
    options
  } = cookie;
  const stringValue = typeof value === "object" ? "j:" + JSON.stringify(value) : String(value);

  if ("maxAge" in options) {
    var _options$maxAge, _options$maxAge2;

    options.expires = new Date(Date.now() + ((_options$maxAge = options.maxAge) !== null && _options$maxAge !== void 0 ? _options$maxAge : 0));
    options.maxAge = ((_options$maxAge2 = options.maxAge) !== null && _options$maxAge2 !== void 0 ? _options$maxAge2 : 0) / 1000;
  }

  let setCookieHeader = (_res$getHeader = res.getHeader("Set-Cookie")) !== null && _res$getHeader !== void 0 ? _res$getHeader : [];

  if (!Array.isArray(setCookieHeader)) {
    setCookieHeader = [setCookieHeader];
  }

  const cookieHeader = (0, _cookie.serialize)(name, String(stringValue), options);
  setCookieHeader.push(cookieHeader);
  res.setHeader("Set-Cookie", setCookieHeader);
}